using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImageSharpApp.AlgProcessor.Forms
{
    partial class FilterNonLinISEFForm : Form
    {
        private bool userChanged = false;
        private FilterNonLinISEFParams pars = null;

        public FilterNonLinISEFParams Params
        {
            get
            {
                return this.pars;
            }
        }

        public FilterNonLinISEFForm(FilterNonLinISEFParams pars)
        {
            InitializeComponent();

            this.pars = pars;

            this.userChanged = false;
            trackBarSmoothing.Minimum = (int)(pars.SmoothingRange.Min * numericUpDownSmoothing.DecimalPlaces * 10f);
            trackBarSmoothing.Maximum = (int)(pars.SmoothingRange.Max * numericUpDownSmoothing.DecimalPlaces * 10f);
            trackBarSmoothing.Value = (int)(pars.SmoothingFactor * numericUpDownSmoothing.DecimalPlaces * 10f);
            trackBarSmoothing.TickStyle = TickStyle.None;
            numericUpDownSmoothing.Minimum = (decimal)pars.SmoothingRange.Min;
            numericUpDownSmoothing.Maximum = (decimal)pars.SmoothingRange.Max;
            numericUpDownSmoothing.Value = (decimal)pars.SmoothingFactor;
            this.userChanged = true;
        }

        public FilterNonLinISEFForm()
        {
            InitializeComponent();
        }

        private void trackBarSmoothing_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                float smooth = trackBarSmoothing.Value / (numericUpDownSmoothing.DecimalPlaces * 10f);
                this.pars.SmoothingFactor = smooth;
                numericUpDownSmoothing.Value = (decimal)Math.Min(this.pars.SmoothingRange.Max, Math.Max(this.pars.SmoothingRange.Min, smooth));
                userChanged = true;
            }
        }

        private void numericUpDownSmoothing_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                float smooth = (float)numericUpDownSmoothing.Value;
                this.pars.SmoothingFactor = smooth;
                trackBarSmoothing.Value = (int)Math.Min(this.pars.SmoothingRange.Max * numericUpDownSmoothing.DecimalPlaces * 10, Math.Max(this.pars.SmoothingRange.Min * numericUpDownSmoothing.DecimalPlaces * 10, smooth * numericUpDownSmoothing.DecimalPlaces * 10));
                userChanged = true;
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Dispose();
        }
    }
}